c  Program computes PSD curve for given input of PSD functions
c    Functions include
c      white noise
c      power law noise
c      power law noise with Gauss-Markov roll-off
c      band pass filtered
c      spiked noise
c
      print*,' Input the sampling interval in days'
      read(5,*)tsam
      fny=0.5*(365.25/tsam)
      fs=365.25/tsam
      print*,' Input the length of the data set in years'
      read(5,*)tlen
      fl=1/tlen
      npts=int(fny/fl)+1
      print*,' Input parameters for first power law noise'
      print*,' Input the index (n=2 for random walk noise)'
      read(5,*)fexp1
      print*,' Input the amplitude'
      read(5,*)amp_pl
      if (amp_pl .eq. 0) amp_pl=0.00001
      print*,' Input frequency (c/yr) for G-M part'
      read(5,*)fgm
c      psd_db=2.8384+20.*alog10(amp_pl) - 8.0*fexp
c      psd_db=5.0*fexp1*alog10(fs)-7.399*fexp1-10*alog10(fs)+2.076
      psd_db=10.0*alog10(2.0)-10.*fexp1*alog10(2.0*3.1415926)
     & +5.0*fexp1*alog10(fs)-10.*alog10(fs)
c      print*,psd_db,psd_dbx
      
      if (abs(amp_pl) .ne. 0) then
         pow_db=20*alog10(amp_pl)+psd_db
         print*,' first power law',pow_db,' db', amp_pl,fexp 
         P1o=10**(pow_db/10.)
      else
         P1o=0.0
      end if
c      print*,psd
      print*,' Input parameters for SECOND power law noise'
      print*,' Input the index (n=2 for random walk noise)'
      read(5,*)fexp2
      print*,' Input the amplitude'
      read(5,*)amp_pl
c      if (amp_pl .eq. 0) amp_pl=0.00001
c      psd_db=2.8384+20.*alog10(amp_pl) - 8.0*fexp
     
c      psd_db=5.0*fexp2*alog10(fs)-7.399*fexp2-10*alog10(fs)+2.076
      psd_db=10.0*alog10(2.0)-10.*fexp1*alog10(2.0*3.1415926)
     & +5.0*fexp1*alog10(fs)-10.*alog10(fs)      
c      print*,5.0*fexp2*alog10(fs),7.399*fexp2,10*alog10(fs),2.076
c      psd_db1=5.0*fexp2*log10(fs)-7.399*fexp2-10*log10(fs)+2.076
      print*,fexp2,fs,psd_db,pow_db1
      if (abs(amp_pl) .ne. 0) then
         pow_db=20*alog10(amp_pl)+psd_db
         print*,' 2nd power law',pow_db,' db', amp_pl,fexp2 
         P2o=10**(pow_db/10.)
      else
         P2o=0.0
      end if

      print*,' '
      print*,' Input the white-noise standard deviation'
      read(5,*)sigma
      Pw=sigma**2/fny
      print*,Pw,10.*alog10(Pw)
      print*,' '
      print*,' Input parameters for band-pass filtered noise'
      print*,' input the pass band parameters flow, fhigh, c/yr'
      read(5,*)flow, fhigh
      if (fhigh .lt. flow) then
        tmp=flow
        flow=fhigh
        fhigh=tmp
      end if
      print*,flow,fhigh
      print*,' Input the number of poles (1,2,3,or 4)'
      read(5,*)npole
      print*,' Input the amplitude'
      read(5,*)amp_bp
      print*,' '
      print*,' Input spike noise'
      print*,' Input its frequency, c/yr'
      read(5,*)fspike
      print*,' Input its amplitude'
      read(5,*)amp_sp
      Ps=(1.0/fl)*(amp_sp**2)/2.

      print*,P1o,fexp1,P2o,fexp2
       fgm=fgm/(2.0*3.14159265)
      do 1 i=1,npts
        freq=fl*float(i)
c  power law
        powPL1=P1o
         powPL2=P2o
c      fgm=fgm/(2.0*3.14159265)
       if (fexp1 .ne. 0) powPL1=P1o/(fgm**fexp1 + freq**fexp1)
       if (fexp2 .ne. 0) powPL2=P2o/( freq**fexp2)
c        powPL1=P1o/(fgm**fexp1 + freq**fexp1)
c        powPL2=P2o/( freq**fexp2)

c  white noise 
        Pw=Pw  

c bandpass filtered
        h=((freq/flow)**2)
     &    /((1.0+((freq/flow)**2))*(1.0+((freq/fhigh)**2)))
c        h=(amp_bp**2)*h
        if (npole .eq. 2) h=h*h
        if (npole .eq. 3) h=h*h*h
        if (npole .eq. 4) h=h*h*h*h
c        powBP=h
c        powBP=(amp_bp**2)*h
        powBP=(4.0*amp_bp**2)*h
c        print*,freq,h

c spike noise
        df=abs(freq-fspike)
        powSP=0.
        if (df .lt. 0.5*fl) powSP=Ps
       
c Sum the noise
        
        pow=powPL1+Pw+powBP+powSP+powPL2
        power=10.*alog10(pow)

      write(11,*)freq,pow,powPL1,Pw,powBP,powSP,powPL2        
      write(10,*)freq,power
1     continue        
      stop
      end
      
      
